PROCEDURE Getcolor
* Note(s) ...: Returns a string as appropriate for SET COLOR TO...
*              which represents current color settings. Uses Attrib.BIN
*              to read attributes from the screen.  Alters the display
*              cell at row 0, column 0.
*
PARAMETERS colornow
LOAD Attrib
* ---A space for testing colors.
test = SPACE(1)
* ---Strings to pass to Attrib.BIN
normal   = SPACE(2)
enhanced = SPACE(2)
* ---Display test space with enhanced color setting.
@ 0, 0 GET test
CLEAR GETS
* ---Put cursor on the space.
@ 0, 0 SAY SPACE(0)
CALL Attrib WITH enhanced
* ---Display test space with normal color setting.
@ 0, 0 SAY test
* ---Put cursor on the space.
@ 0, 0 SAY SPACE(0)
CALL Attrib WITH normal
DO Decode WITH ASC(normal) - 1,   ASC(SUBSTR(normal, 2)) - 1,   normal
DO Decode WITH ASC(enhanced) - 1, ASC(SUBSTR(enhanced, 2)) - 1, enhanced
colornow = normal + "," + enhanced
RELEASE MODULE Attrib
RETURN
* EOP: Getcolor

PROCEDURE Decode
* ---Procedure to translate foreground and background colors
* ---to a string appropriate for SET COLOR TO... which
* ---represents current color settings.
*
PARAMETERS fore, back, result
* ---Colors list for color adapters.
*          0  1  2  3  4  5  6  7
colors  = "N  B  G  BG R  BR GR W  "
intense = IIF(fore > 7, "+", "")
blink   = IIF(back > 7, "*", "")
tfore   = MOD(fore, 8)
tback   = MOD(back, 8)
IF ISCOLOR()
   * ---Translate normal colors using color list for color adapters.
   result = TRIM(SUBSTR(colors, tfore * 3 + 1, 3)) + intense + "/" +;
            TRIM(SUBSTR(colors, tback * 3 + 1, 3)) + blink
ELSE
   * ---Apply rules for monochrome colors.
   DO CASE
   CASE tfore = 1
        * ---Underlined if foreground is 1.
        result = "U" + intense + "/N" + blink
   CASE tfore = 0 .AND. tback = 0
        * ---Black-on-black if foreground and background are 0.
        result = "N" + intense + "/N" + blink
   CASE tfore = 0 .AND. tback = 7
        * ---Reverse if foreground and background are 0.
        result = "N" + intense + "/W" + blink
   OTHERWISE
        * ---In all other cases, white on black.
        result = "W" + intense + "/N" + blink
   ENDCASE
ENDIF
RETURN
* EOP: Decode

